<?php  
/* 
  Plugin Name: Token Manager
  Plugin URI: http://www.codevendor.com/tokenmanager/
  Description: The Token Manager allows web developers to program PHP, HTML, CSS and JavaScript into tokens that can be used throughout Wordpress.
  Author: Codevendor 
  Version: 0.2.3
  Author URI: http://www.codevendor.com 
*/  

// Globals
global $tokenmanager_db_version, $_VARS, $tokenmanager, $isjson;
$tokenmanager_db_version = '0.1';
$_VARS = array('REQUEST_HASERRORS' => 'false');
$tokenmanager = null;
$isjson = false;

// Class for creating tokens
class tokenmanager
{
  // Variables
  private $buffer;

  // Properties
  public function set_buffer($_value) { $this->buffer = $_value; } 
  public function get_buffer() { return $this->buffer; }

  // Initializes the Token Manager
  private function init()
  {
    global $_VARS, $wpdb, $post, $wp_query, $post, $current_site, $blog_id;

    // Check if injecturl
    $injecturl = intval(get_option('tokenmanager_injecturl', 0));

    if($injecturl==1)
    {
      $host = (isset($_SERVER['HTTP_HOST']) && !empty($_SERVER['HTTP_HOST']))? $_SERVER['HTTP_HOST']: '';
      $scheme = (isset($_SERVER['HTTPS']) && !empty($_SERVER['HTTPS']) && $_SERVER['HTTPS']=='on')?'https':'http';
      $url = (isset($_SERVER['REQUEST_URI']) && !empty($_SERVER['REQUEST_URI']))? $_SERVER['REQUEST_URI'] : '';
      $uri = explode('?', $url);
      $uricount = count($uri);
      $query = ($uricount == 2 && isset($uri[1]) && !empty($uri[1])) ? $uri[1] : '';
      $siteurl = "$scheme://$host";
      $fullurl = $siteurl . $url;
      $urlpath = ($uricount > 0 && isset($uri[0]) && !empty($uri[0]))? $uri[0] : '';
      $items = explode('/', $urlpath);
      $itemscount = count($items);
      $filecheck = array_pop($items);
      $filenameparts = explode('.', $filecheck);
      $filenamepartscount = count($filenameparts);
      $filename = ($filenamepartscount == 2 && isset($filenameparts[0]) && !empty($filenameparts[0])) ? $filenameparts[0] : ''; 
      $fileext = ($filenamepartscount == 2 && isset($filenameparts[1]) && !empty($filenameparts[1])) ? $filenameparts[1] : '';
      $fullfilename = (isset($filename) && !empty($filename) && isset($fileext) && !empty($fileext))? "$filename.$fileext" : ''; 

      $_VARS['REQUEST_HOST'] = $host;
      $_VARS['REQUEST_SCHEME'] = $scheme;
      $_VARS['REQUEST_SITEURL'] = $siteurl;
      $_VARS['REQUEST_FULLURL'] = $fullurl;
      $_VARS['REQUEST_QUERY'] = $query;
      $_VARS['REQUEST_URLPATH'] = $urlpath;
      $_VARS['REQUEST_FULLFILENAME'] = $fullfilename;
      $_VARS['REQUEST_FILENAME'] = $filename;
      $_VARS['REQUEST_FILEEXT'] = $fileext;
      $_VARS['REQUEST_TEMPLATESPATH'] = get_template_directory();
      $_VARS['REQUEST_TEMPLATESURL'] = get_bloginfo('template_url');

    }
  }

  // Construct the tokens class
  public function __construct()
  {
    $this->init();
    ob_start(array($this, "obcallback"));
  }

  private function evalex($evaled){ return eval(' ?>'.$evaled.'<?php'); }

  // Injects the tokens into the list
  private function inject_tokens()
  {
    global $wpdb, $post, $_VARS, $current_site, $blog_id;

    $displayerrors = intval(get_option('tokenmanager_displayerrors', 0));

    // Check if injecturl
    $injecturl = intval(get_option('tokenmanager_injecturl', 0));

    if($injecturl==1)
    {
      $_VARS['REQUEST_SITEID'] = (isset($current_site) && isset($current_site->id)) ? $current_site->id : '0';
      $_VARS['REQUEST_BLOGID'] = $blog_id;
      $_VARS['REQUEST_PAGEID'] = $post->ID;
      $_VARS['REQUEST_ISFRONTPAGE'] = (is_front_page()) ? 'true' : 'false';
    }

    $pluginimages = plugin_dir_url( __FILE__ ) . 'icons/';

    // Create custom vars
    $siteid = (isset($current_site) && isset($current_site->id)) ? $current_site->id : '0';;
    $blogid = $blog_id;
    $pageid = $post->ID;
    $isfrontpage = is_front_page();

    // Get the tokens for this page from the database and load into VARS
    $tablename1 = $wpdb->base_prefix . 'tokenmanager';
    $tablename2 = $wpdb->base_prefix . 'tokenmanagerpages';
    $where = '';

    // Check site id and blog main token
    $where .= " a.siteid='$siteid' AND a.blogid='$blogid' AND";

    // Check site id and blog id
    $where .= " b.siteid='$siteid' AND b.blogid='$blogid' AND";

    // Check if file is frontpage
    if($isfrontpage)
    {
      $where = "$where b.pageid='0' OR $where b.pageid='-1'";
    }
    else
    {
      $where = "$where b.pageid='-1' OR $where b.pageid='$pageid'"; 
    }

    $items = $wpdb->get_results("SELECT DISTINCT a.id as id, a.tokenname as tokenname, 
                                 a.htmlvalue as htmlvalue,
                                 a.phpvalue as phpvalue,
                                 a.cssvalue as cssvalue,
                                 a.jsvalue as jsvalue
                                 FROM $tablename1 a 
                                 LEFT JOIN $tablename2 b ON a.id = b.tokenid
                                 WHERE $where ORDER BY a.typeid DESC;");

    foreach ($items as $item) 
    {
      if (!array_key_exists($item->tokenname, $_VARS))
      {
        $name = stripslashes($item->tokenname);
        //$value = (!empty($item->phpvalue)) ? stripslashes($item->phpvalue) : '';
        //$value = (strstr($value, '{php}')) ? $value : "{php} $value {/php}";
        //$value .= (!empty($item->cssvalue)) ? "\r\n<style type=\"text/css\">\r\n" . stripslashes($item->cssvalue) . "\r\n</style>\r\n" : '';
        //$value .= (!empty($item->htmlvalue)) ? stripslashes($item->htmlvalue) : '';
        //$value .= (!empty($item->jsvalue)) ? "\r\n<script type=\"text/javascript\">\r\n" . stripslashes($item->jsvalue) . "\r\n</script>\r\n" : '';
        
        $item->phpvalue = (!empty($item->phpvalue)) ? '<?php ' . stripslashes($item->phpvalue) . ' ?>' : '';
        $item->cssvalue = (!empty($item->cssvalue)) ? "\r\n<style type=\"text/css\">\r\n" . stripslashes($item->cssvalue) . "\r\n</style>\r\n" : '';
        $item->htmlvalue = (!empty($item->htmlvalue)) ? stripslashes($item->htmlvalue) : '';
        $item->jsvalue = (!empty($item->jsvalue)) ? "\r\n<script type=\"text/javascript\">\r\n" . stripslashes($item->jsvalue) . "\r\n</script>\r\n" : '';

        $value = $item->phpvalue . $item->cssvalue . $item->htmlvalue . $item->jsvalue;          

        /* /<\?php(.*)\?>/ */
        preg_match_all("/\<\?php(.*)\?\>/msU", $value, $matches, PREG_SET_ORDER);

//$_VARS['test'] = var_export($matches,true);
        if(count($matches)>0)
        {
          foreach ($matches as $match) 
          {
            $GLOBALS["currentbuffer"] = '';

            $match[1] = str_replace('echo', ' $GLOBALS["currentbuffer"] .= ', $match[1]);

            // Replace Echo with new buffer. Variable
            $return = eval($match[1]);

            if($return === false && ( $err = error_get_last() ) && $displayerrors==1) 
            { 
              // Set haserror
              $_VARS['REQUEST_HASERRORS'] = 'true';

              // Find where occurrance is and what file.
              $codetype = 'Unknown';
              if(strstr($item->phpvalue, $match[0])){ $codetype = 'PHP Code'; }
              if(strstr($item->cssvalue, $match[0])){ $codetype = 'CSS Code'; }
              if(strstr($item->htmlvalue, $match[0])){ $codetype = 'HTML Code'; }
              if(strstr($item->jsvalue, $match[0])){ $codetype = 'JS Code'; }

              $GLOBALS["currentbuffer"] = '<div style="border: solid 1px black; padding: 10px; background-color: #E1E1E1; max-width: 600px;">' . 
                                '<span style="display: block; border-bottom: solid 1px white; height: 32px; line-height: 33px;' .
                                'background: transparent url(' . $pluginimages . 'icon1_32.png) no-repeat; padding: 0px 0px 5px 40px; margin: 0px 0px 5px 0px; font-weight: bold;">' . 
                                'Error Processing Token!</span>' . 
                                '<strong>Token:</strong> ' . $item->tokenname . '<span style="margin: 0px 10px 0px 10px; color: white;">|</span><strong>Code Type:</strong> ' . $codetype . '<br>' .
                                '<strong>Message:</strong> ' . $err['message'] . '<br>' .
                                '</div>';

              //$value = str_replace($match[0], $GLOBALS["currentbuffer"], $value);
              //$_VARS[$name] = $value;
              $_VARS[$name] = $GLOBALS["currentbuffer"];
              return;
            }
            else
            {
              $value = str_replace($match[0], $GLOBALS["currentbuffer"], $value);
            }
          }
          
          // Check for unclosed php
          if(strstr($value, '<?php') || strstr($value, '?>'))
          { 
            if($displayerrors==1)
            {
              $_VARS[$name] = '<div style="border: solid 1px black; padding: 10px; background-color: #E1E1E1; max-width: 600px;">' . 
                                '<span style="display: block; border-bottom: solid 1px white; height: 32px; line-height: 33px;' .
                                'background: transparent url(' . $pluginimages . 'icon1_32.png) no-repeat; padding: 0px 0px 5px 40px; margin: 0px 0px 5px 0px; font-weight: bold;">' . 
                                'Error Processing Token!</span>' . 
                                '<strong>Token:</strong> ' . $item->tokenname . '<span style="margin: 0px 10px 0px 10px; color: white;">|</span><strong>Code Type:</strong> HTML, CSS, JS<br>' .
                                '<strong>Message:</strong> Unprocessed PHP, make sure you have &#60;&#63;php and &#63;&#62; around your inline PHP code.<br>' .
                                '</div>';
            }
            else
            {
              $_VARS[$name] = '';
            }
          }
          else
          {
            $_VARS[$name] = $value;
          }
          
        }
        else
        {
          // Check for unclosed php
          if(strstr($value, '<?php') || strstr($value, '?>'))
          { 
            if($displayerrors==1)
            {
              $_VARS[$name] = '<div style="border: solid 1px black; padding: 10px; background-color: #E1E1E1; max-width: 600px;">' . 
                                '<span style="display: block; border-bottom: solid 1px white; height: 32px; line-height: 33px;' .
                                'background: transparent url(' . $pluginimages . 'icon1_32.png) no-repeat; padding: 0px 0px 5px 40px; margin: 0px 0px 5px 0px; font-weight: bold;">' . 
                                'Error Processing Token!</span>' . 
                                '<strong>Token:</strong> ' . $item->tokenname . '<span style="margin: 0px 10px 0px 10px; color: white;">|</span><strong>Code Type:</strong> HTML, CSS, JS<br>' .
                                '<strong>Message:</strong> Unprocessed PHP, make sure you have &#60;&#63;php and &#63;&#62; around your inline PHP code.<br>' .
                                '</div>';
            }
            else
            {
              $_VARS[$name] = '';
            }
          }
          else
          {
            $_VARS[$name] = $value;
          }
        }        
      }
    }
  }

  // Processes the tokens and replaces them in the page.
  public function process()
  {
    global $_SERVER, $_VARS, $isjson;

    // Has json strip out surround admin console.
    if($isjson)
    {
      $buf =  explode('<jsonobject>', $this->get_buffer());
      if(count($buf) > 1)
      {
        $buf =  explode('</jsonobject>', $buf[1]);
        $this->set_buffer($buf[0]);
      }
    }

    // Set the property. Make sure to check that page is not admin.
    if(strstr($_SERVER['REQUEST_URI'], 'wp-admin'))
    {
      // Nothing
    }
    else
    {
      $this->inject_tokens();
      
      // For Testing ONLY!!!
      $displaykeys = intval(get_option('tokenmanager_displaykeys', 0));

      if($displaykeys==1)
      {
        $this->buffer .= '<div style="background-color: white; margin: 10px 0px 20px 0px; border: solid 1px black; padding: 10px;">' . 
                         '<span style="font-weight: bold; background: transparent url(' . plugin_dir_url( __FILE__ ) . 'icons/icon1_32.png) no-repeat; display: block; line-height: 32px; font-size: large; padding: 0px 0px 0px 40px; margin: 0px 0px 20px 0px">Token Manager - Token Key Pairs</span>';
        foreach($_VARS as $key => $value)
        {
          $code = (empty($value)) ? 'Not Set' : '<code>'  . htmlentities($value) . '</code>';
          $this->buffer .= "<strong style=\"color: #3f8242; margin: 0px 40px 0px 40px; display: block; font-size: medium\">$key</strong><p style=\"margin: 0px 50px 10px 50px;\">$code</p>";
        }
        $this->buffer .= '</div>';
        $this->set_buffer(tokenmanager::datareplace($this->get_buffer(), $_VARS));
      }
      else
      {
        $this->set_buffer(tokenmanager::datareplace($this->get_buffer(), $_VARS));
      }
    }
  }

  // Handles the ob_start callback.
  public function obcallback($_buffer)
  { 
    global $tokenmanager;
    $tokenmanager->set_buffer($_buffer);
    $tokenmanager->process();
    return $tokenmanager->get_buffer();
  }


  // Loads a file with locking.
  public static function loadfile($_file)
  {
    if (!file_exists($_file)){ die('Unable to load file ' . $_file . '.'); }
		
    $data = '';
		
    $fp = fopen($_file, 'r');
		
    if(flock($fp, LOCK_EX))
    {
      $data = fread($fp, filesize($_file));
      flock($fp, LOCK_UN);
    }
    fclose($fp);
		
    return $data;	
  }

  // Processes process data
  public static function datareplace($_html, $_tags = array())
  {
    if (sizeof($_tags) < 1){ return; }
		
    $buffer=$_html;

    $_tags = array_reverse($_tags);
		
    foreach($_tags as $tag => $data)
    {
      //echo $tag . '<br>';
      if(gettype($data)!='array')
      {
        $buffer = preg_replace('#\{' . $tag . '\}#', $data, $buffer);
      }
    }
		
    return $buffer;
  }

  // Processes the current html and replaces the tokens.
  public function processtemplate($_command, $_file)
  {
    $buffer='';
		
    // Check if array or make it array.
    if($this->gettype($_file)=='string'){ $_file = array($_file); }
		
    if (sizeof($_file) < 1){ return; }
		
    foreach($_file as $tag)
    {
      if(file_exists($tag))
      {
        $buffer .= tokenmanager::loadfile($tag);
      }
    }
	  	
    $this->html = preg_replace('#\{' . $_command . '\}#', $buffer, $this->html);
  }

  // Starts the token manager.
  public static function start()
  {
    global $tokenmanager;
    $tokenmanager = new tokenmanager();
  }

  // Ends the token manager.
  public static function stop()
  {
    //echo 'done';
  }

  public static function posts($_data)
  {
    // Protect input data from over riding tokens
    if(current_user_can('manage_options'))
    {
      return $_data;
    }
    else
    {
      $_data['post_content'] = str_replace('{', '&#123;', str_replace('}', '&#125;',  $_data['post_content']));
    }
  }

  public static function comments($_data)
  {
    // Protect input data from over riding tokens
    $_data['comment_content'] = str_replace('{', '&#123;', str_replace('}', '&#125;',  $_data['comment_content']));
    return $_data;
  }

  // Creates the tables.
  public static function create()
  {
    // Variables
    global $wpdb;

    // Needed to use dbdelta.
    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');

    $tab1 = $wpdb->base_prefix . 'tokenmanager';
    $tab2 = $wpdb->base_prefix . 'tokenmanagerversions';
    $tab3 = $wpdb->base_prefix . 'tokenmanagertypes';
    $tab4 = $wpdb->base_prefix . 'tokenmanagertypesversions';
    $tab5 = $wpdb->base_prefix . 'tokenmanagerpages';

    global $tokenmanager_db_version;
    $installed_ver = get_option('tokenmanager_db_version');

    if($wpdb->get_var("SHOW TABLES LIKE '$tab1'") != $tab1 || $installed_ver != $tokenmanager_db_version)
    {
      $sql1 = "CREATE TABLE $tab1 (
	  id int(10) unsigned NOT NULL AUTO_INCREMENT,
	  datecreated int(10) unsigned DEFAULT '0' NOT NULL,
          lastupdated int(10) unsigned DEFAULT '0' NOT NULL,
          siteid int(10) unsigned DEFAULT '0' NOT NULL,
          blogid int(10) unsigned DEFAULT '0' NOT NULL,
	  tokenname VARCHAR(38) NOT NULL,
          htmlvalue text NOT NULL,
          phpvalue text NOT NULL,
          cssvalue text NOT NULL,
          jsvalue text NOT NULL,
          description VARCHAR(250) NOT NULL,
	  authorid int(10) unsigned DEFAULT '0' NOT NULL,
          typeid int(10) unsigned DEFAULT '0' NOT NULL,
          frontpage TINYINT(1) DEFAULT '0' NOT NULL,
          allpages TINYINT(1) DEFAULT '0' NOT NULL,
          active TINYINT(1) DEFAULT '0' NOT NULL,
          version int(10) unsigned DEFAULT '0' NOT NULL,
          history text NOT NULL,
	  UNIQUE KEY id (id)
      );";

      dbDelta($sql1);

      $sql2 = "CREATE TABLE $tab2 (
	  id int(10) unsigned NOT NULL AUTO_INCREMENT,
          tokenid int(10) unsigned DEFAULT '0' NOT NULL,
	  datecreated int(10) unsigned DEFAULT '0' NOT NULL,
          lastupdated int(10) unsigned DEFAULT '0' NOT NULL,
          siteid int(10) unsigned DEFAULT '0' NOT NULL,
          blogid int(10) unsigned DEFAULT '0' NOT NULL,
	  tokenname VARCHAR(38) NOT NULL,
          htmlvalue text NOT NULL,
          phpvalue text NOT NULL,
          cssvalue text NOT NULL,
          jsvalue text NOT NULL,
          description VARCHAR(250) NOT NULL,
	  authorid int(10) unsigned DEFAULT '0' NOT NULL,
          typeid int(10) unsigned DEFAULT '0' NOT NULL,
          active TINYINT(1) DEFAULT '0' NOT NULL,
          version int(10) unsigned DEFAULT '0' NOT NULL,
	  UNIQUE KEY id (id)
      );";

      dbDelta($sql2);

      $sql3 = "CREATE TABLE $tab3 (
	  id int(10) unsigned NOT NULL AUTO_INCREMENT,
          datecreated int(10) unsigned DEFAULT '0' NOT NULL,
          lastupdated int(10) unsigned DEFAULT '0' NOT NULL,
	  tokentype VARCHAR(38) NOT NULL,
          tokendescription VARCHAR(250) NOT NULL,
          siteid int(10) unsigned DEFAULT '0' NOT NULL,
          blogid int(10) unsigned DEFAULT '0' NOT NULL,
          authorid int(10) unsigned DEFAULT '0' NOT NULL,
	  orderof int(10) unsigned DEFAULT '0' NOT NULL,
          active tinyint(1) DEFAULT '0' NOT NULL,
          version int(10) unsigned DEFAULT '0' NOT NULL,
          history text NOT NULL,
	  UNIQUE KEY id (id)
      );";

      dbDelta($sql3);

      $sql4 = "CREATE TABLE $tab4 (
	  id int(10) unsigned NOT NULL AUTO_INCREMENT,
          tokentypeid int(10) unsigned DEFAULT '0' NOT NULL,
          datecreated int(10) unsigned DEFAULT '0' NOT NULL,
          lastupdated int(10) unsigned DEFAULT '0' NOT NULL,
	  tokentype VARCHAR(38) NOT NULL,
          tokendescription VARCHAR(250) NOT NULL,
          siteid int(10) unsigned DEFAULT '0' NOT NULL,
          blogid int(10) unsigned DEFAULT '0' NOT NULL,
          authorid int(10) unsigned DEFAULT '0' NOT NULL,
	  orderof int(10) unsigned DEFAULT '0' NOT NULL,
          active tinyint(1) DEFAULT '0' NOT NULL,
          version int(10) unsigned DEFAULT '0' NOT NULL,
	  UNIQUE KEY id (id)
      );";

      dbDelta($sql4);

      $sql5 = "CREATE TABLE $tab5 (
	  id int(10) unsigned NOT NULL AUTO_INCREMENT,
          datecreated int(10) unsigned DEFAULT '0' NOT NULL,
          lastupdated int(10) unsigned DEFAULT '0' NOT NULL,
          siteid int(10) unsigned DEFAULT '0' NOT NULL,
          blogid int(10) unsigned DEFAULT '0' NOT NULL,
	  pageid int(10) signed DEFAULT '0' NOT NULL,
          tokenid int(10) unsigned DEFAULT '0' NOT NULL,
	  UNIQUE KEY id (id)
      );";
      
      dbDelta($sql5);

      update_option('tokenmanager_db_version', $tokenmanager_db_version);
    }

    add_option('tokenmanager_db_version', $tokenmanager_db_version);
  }

  // Creates the wordpress menus. Add null to parent slug if you dont want it to be attached.
  public static function adminmenus()
  {
    add_menu_page('Token Manager', 'Tokens', 'activate_plugins', 'tokenmanager', 'tokenmanager::tokens', plugin_dir_url( __FILE__ ) . 'icons/icon1_16.png');
    add_submenu_page('tokenmanager', 'Token Manager - Add New Token', 'Add New Token', 'activate_plugins', 'tokenmanageradd', 'tokenmanager::add');
    add_submenu_page('tokenmanager', 'Token Manager - Token Types', 'Token Types', 'activate_plugins', 'tokenmanagertypes', 'tokenmanager::types');
    add_submenu_page('tokenmanager', 'Token Manager - Token Types - Add New Type', 'Add New Type', 'activate_plugins', 'tokenmanageraddtype', 'tokenmanager::typeadd');
    add_submenu_page('tokenmanager', 'Token Manager - Professional', 'Backup System', 'activate_plugins', 'tokenmanagerpro', 'tokenmanager::pro');
    add_submenu_page('tokenmanager', 'Token Manager - Settings', 'Settings', 'activate_plugins', 'tokenmanagersettings', 'tokenmanager::settings');
    add_submenu_page('tokenmanager', 'Token Manager - Info', 'Information', 'activate_plugins', 'tokenmanagerinfo', 'tokenmanager::info');
    add_submenu_page(null, 'Token Manager - JSON', '', 'activate_plugins', 'tokenmanagerjson', 'tokenmanager::json');
    add_submenu_page(null, 'Token Manager - Edit Token', '', 'activate_plugins', 'tokenmanageredit', 'tokenmanager::edit');
    add_submenu_page(null, 'Token Manager - Edit Token Type', '', 'activate_plugins', 'tokenmanagertypeedit', 'tokenmanager::typeedit');
  }

  public static function tokens(){ include('tokens.php'); }
  public static function add(){ include('tokenadd.php'); }
  public static function edit(){ include('tokenedit.php'); }
  public static function types(){ include('types.php'); }
  public static function typeadd(){ include('typeadd.php'); }
  public static function typeedit(){ include('typeedit.php'); }
  public static function settings(){ include('settings.php'); }
  public static function pro(){ include('pro.php'); }
  public static function info(){ include('info.php'); }
  public static function json(){ global $isjson; $isjson=true; include('json.php'); }

}

/* Add the wordpress actions. */
register_activation_hook(__FILE__,'tokenmanager::create');
add_action('plugins_loaded', 'tokenmanager::start');
add_action('shutdown', 'tokenmanager::stop');
add_action('admin_menu', 'tokenmanager::adminmenus');
add_action('wp_insert_post_data', 'tokenmanager::posts', 1, 1);
add_action('preprocess_comment', 'tokenmanager::comments', 1, 1);

// Check if injecturl
$replacep = intval(get_option('tokenmanager_replacep', 0));

if($replacep==1)
{
  /* Remove p tags */
  remove_filter('the_content', 'wpautop');
}

?>
