<?php

class tokentypeadd
{
  // Variables
  private $error;
  private $errortokentype;
  private $errortokendescription;

  private $icon;
  private $tablenametypes;
  private $tablenametokens;

  // Properties
  public function set_error($_value) { $this->error = $_value; } 
  public function get_error() { return $this->error; }
  public function set_errortokentype($_value) { $this->errortokentype = $_value; } 
  public function get_errortokentype() { return $this->errortokentype; }
  public function set_errortokendescription($_value) { $this->errortokendescription = $_value; } 
  public function get_errortokendescription() { return $this->errortokendescription; }

  public function set_icon($_value) { $this->icon = $_value; } 
  public function get_icon() { return $this->icon; }
  public function set_tablenametypes($_value) { $this->tablenametypes = $_value; } 
  public function get_tablenametypes() { return $this->tablenametypes; }
  public function set_tablenametokens($_value) { $this->tablenametokens = $_value; } 
  public function get_tablenametokens() { return $this->tablenametokens; }

  // Construct the token add
  public function __construct()
  {
    global $_POST, $wpdb;

    $this->set_icon(plugin_dir_url( __FILE__ ) . 'icons/icon1_32.png');
    $this->set_tablenametypes($wpdb->base_prefix . 'tokenmanagertypes'); 
    $this->set_tablenametokens($wpdb->base_prefix . 'tokenmanager');      

    $this->init();
  }

  // Initializes the page.
  function init()
  {
    global $_POST, $wpdb, $current_site, $blog_id;

    // Create custom vars
    $siteid = (isset($current_site) && isset($current_site->id)) ? $current_site->id : '0';
    $blogid = $blog_id;
  
    $haserror = false;

    // Process Form
    if(isset($_POST['addtokentype']))
    {
      // Check required.
      if(!isset($_POST['tokentype']) || empty($_POST['tokentype'])){ $haserror = true; $this->set_errortokentype('<span style="color: Red; display: block;">Token Type is a required field!</span>'); }
      if(!isset($_POST['tokendescription']) || empty($_POST['tokendescription'])){ $haserror = true; $this->set_errortokendescription('<span style="color: Red; display: block;">Token Description is a required field!</span>'); }

      if(!$haserror)
      {
        $tokentype = mysql_real_escape_string($_POST['tokentype']);
        $tokendescription = mysql_real_escape_string($_POST['tokendescription']);

        $authorid = wp_get_current_user();
        $authorid = $authorid->ID;
        $tablename = $this->get_tablenametypes();

        // Check if type already exists
        $toke = $wpdb->get_var("SELECT count(*) FROM $tablename WHERE tokentype = '$tokentype' AND active='1' AND siteid='$siteid' AND blogid='$blogid' LIMIT 1");

        if($toke>0){ $haserror = true; $this->set_errortokentype('<span style="color: Red; display: block;">Token Type already exists!</span>'); }

        if(!$haserror)
        {
          // Sets the history for the insert
          $remoteip = $_SERVER['REMOTE_ADDR'];
          $occurred = date("D, M j, Y G:i:s T");
          $history = mysql_real_escape_string("<?xml version=\"1.0\" encoding=\"utf-8\" ?>
<tokenmanagertypes>
  <history>
    <event remoteip=\"$remoteip\" dateoccurred=\"$occurred\" author=\"$authorid\" type=\"create\" status=\"Created a new token type in the token manager.\"  />
    <!-- NEXT -->
  </history>
</tokenmanagertypes>");

          // Insert into database
          $wpdb->query("INSERT INTO $tablename (id, datecreated, lastupdated, tokentype, tokendescription, siteid, blogid, authorid, orderof, active, version, history) 
                        VALUES (null, UNIX_TIMESTAMP(), UNIX_TIMESTAMP(), '$tokentype', '$tokendescription', '$siteid', '$blogid', '$authorid', '0', '1', '1', '$history')");

          // Get last insert id.
          $id = $wpdb->insert_id;
        }
      }

      if($haserror)
      {
        $this->set_error('<span style="color: Red;">Your form had the following errors!</span>');
      }
      else
      {
        $this->set_error('<span style="color: Green;">New Type Created Successfully!</span>');

        // Reset form.
        $_POST['tokentype'] = '';
        $_POST['tokendescription'] = '';
      }
    }
  }
}

// Build class
$tokentypeadd = new tokentypeadd();

$_POST = array_map('stripslashes_deep', $_POST);
$_GET = array_map('stripslashes_deep', $_GET);
  
?>

<div class="wrap">
  <div class="icon32 icon32-posts-post" id="icon-edit" style="background: transparent url(<?php echo $tokentypeadd->get_icon(); ?>) 0px 0px no-repeat"><br></div>
  <h2>Token Manager - Add New Type <a class="add-new-h2" href="admin.php?page=tokenmanagertypes">View All Types</a></h2>
  <p>Create a new token type in the wordpress token manager.</p>
  <form method="POST" action="<?php echo $_SERVER['REQUEST_URI']; ?>">

<?php echo $tokentypeadd->get_error(); ?>
<table class="form-table">
<tbody>
  <tr class="form-field form-required">
    <th scope="row"><label for="tokentype">Token Type <span class="description">(required)</span></label></th>
      <td>
        <input type="text" aria-required="true" id="tokentype" name="tokentype" value="<?php echo (isset($_POST['tokentype']) && !empty($_POST['tokentype']))?$_POST['tokentype']:''; ?>">
        <?php echo $tokentypeadd->get_errortokentype(); ?>
      </td>
  </tr>
    <tr class="form-field form-required">
      <th scope="row"><label for="tokendescription">Type Description <span class="description">(required)</span></label></th>
        <td>
          <textarea id="tokendescription" name="tokendescription" rows="12"><?php echo (isset($_POST['tokendescription']) && !empty($_POST['tokendescription']))?$_POST['tokendescription']:''; ?></textarea>
          <?php echo $tokentypeadd->get_errortokendescription(); ?>
        </td>
    </tr>
    <tr>
      <th scope="row"></th>
        <td><input class="button-primary" type="submit" name="addtokentype" value="Add Type" id="submitbutton" /></td>
    </tr>
</tbody></table>
</form>
</div>
